package com.example.elbuenopeso.adapters

import android.content.Context
import android.content.Intent
import android.database.Cursor
import android.net.Uri
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.CursorAdapter
import android.widget.ImageView
import android.widget.TextView
import com.example.elbuenopeso.R
import com.example.elbuenopeso.database.DBHelper

class DbAdapter(context: Context, c: Cursor, layout: Int): CursorAdapter(context, c) {
    val item_layout = layout
    override fun newView(context: Context, cursor: Cursor, viewGroup: ViewGroup): View {
        return LayoutInflater.from(context).inflate(item_layout, viewGroup, false)
    }

    fun usingJavaStringFormat(input: Double, scale: Int) = String.format("%.${scale}f", input)

    override fun bindView(view: View, context: Context, cursor: Cursor) {
        val titleTextView: TextView = view.findViewById(R.id.itemListViewTitleView)
        val addressTextView: TextView = view.findViewById(R.id.itemListViewTextView)
        val imageView: ImageView = view.findViewById(R.id.itemListViewImageView)
        val prixView: TextView = view.findViewById(R.id.itemListViewPrixView)

        val title: String = cursor.getString(cursor.getColumnIndexOrThrow(DBHelper.TITLE))
        val address: String = cursor.getString(cursor.getColumnIndexOrThrow(DBHelper.ADDRESS))
        val prix: Double = cursor.getDouble(cursor.getColumnIndexOrThrow(DBHelper.PRIX))
        val image: String = cursor.getString(cursor.getColumnIndexOrThrow(DBHelper.IMAGE))
        val num: String = cursor.getString(cursor.getColumnIndexOrThrow(DBHelper.NUM))

        titleTextView.text = title
        addressTextView.text = address
        prixView.text = "${usingJavaStringFormat(prix, 2)} €"

        val button: Button = view.findViewById(R.id.buttonCall)

        button.setOnClickListener {
            Log.d("TAG", "TEST")
            val callIntent = Intent(Intent.ACTION_DIAL)
            callIntent.data = Uri.parse("tel:$num")
            context.startActivity(callIntent)
        }



        imageView.setImageURI(Uri.parse(image))
    }
}